05Robot 3.0

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Static Public Attributes | Properties | List of all members
Camera_Basler_GigE Class Reference
Computer Vision Module

Basler Gigabit Ethernet camera interface class. More...

`#include <Camera_Basler_GigE.h>`

Inheritance diagram for Camera_Basler_GigE:

## Public Member Functions
| Camera_Basler_GigE ()
| Initializes default parameters. More...
int | width () const
| Gets picture width in pixels. More...
void | setWidth (const int &width)
| Sets picture width in pixels. More...
int | height () const
| Gets picture height in pixels. More...
void | setHeight (const int &height)
| Sets picture height in pixels. More...
int | offsetX () const
| Gets picture horizontal offset in pixels. More...
void | setOffsetX (const int &offsetx)
| Sets picture horizontal offset in pixels. More...
int | offsetY () const
| Gets picture vertical offset in pixels. More...
void | setOffsetY (const int &offsety)
| Sets picture vertical offset in pixels. More...
int | exposureTimeRaw () const
| Gets raw exposure time. More...
void | setExposureTimeRaw (const int &exposuretimeraw)
| Sets raw exposure time. More...
int | balanceRatioRaw_red () const
| Gets red color balance ratio. More...
void | setBalanceRatioRaw_red (const int &balanceratioraw_red)
| Sets red color balance ratio. More...
int | balanceRatioRaw_green () const
| Gets green color balance ratio. More...
void | setBalanceRatioRaw_green (const int &balanceratioraw_green)
| Sets green color balance ratio. More...
int | balanceRatioRaw_blue () const
| Gets green color balance ratio. More...
void | setBalanceRatioRaw_blue (const int &balanceratioraw_blue)
| Sets green color balance ratio. More...
int | connect (int camera_id)
| Connects to camera with given ID. More...
int | start ()
| Starts acquisition. More...
int | sync ()
| Sends software trigger to camera. More...
int | grab (cv::Mat *output=NULL)
| Copies current internal buffer to resultBuffer or given output Mat. More...
int | stop ()
| Stops acquisition. More...
int | disconnect ()
| Disconnects from camera. More...
Public Member Functions inherited from Camera
| Camera ()
Public Member Functions inherited from cXmlIO
| cXmlIO (int _xmlID=0, QObject *parent=nullptr)
virtual QString | sXmlKey ()
| Generates key of XML entry (as name of the serialised class is) More...
virtual void | findInXML (QString &fileName, bool compareXmlID=true)
| serches th file for XML key corr to class name and fill class properties according to entries found More...
virtual void | writeXml (QXmlStreamWriter &xml)
| Writes XML entries to file. Can be overloaded to save additional data, apart from object properties. More...
virtual void | readXml (QXmlStreamReader &xml)
| Called by findInXML. Reads XML entries. Has to be overloaded if additional data was written to file in object entry. More...
virtual void | writeCsvData (QXmlStreamWriter &stream, QString key, const QVector< QVector< double > > &s)
virtual void | writeCsvVector (QXmlStreamWriter &stream, QString key, const QVector< double > &s)
virtual void | readCsvData (QXmlStreamReader &stream, QVector< QVector< double > > &s)
virtual void | readCsvVector (QXmlStreamReader &stream, QVector< double > &s)
virtual void | write64BaseData (QXmlStreamWriter &stream, QString key, const QVector< QVector< double > > &s)
virtual void | read64BaseData (QXmlStreamReader &stream, QVector< QVector< double > > &s)
template<typename T >
void | writeData (QXmlStreamWriter &stream, QString key, const T &data)
template<typename T >
void | readData (QXmlStreamReader &stream, T &data)
int | getXmlID () const
void | setXmlID (int value)

## Static Public Member Functions
static void | refreshDevices ()
| Refreshes connected devices. More...
Static Public Member Functions inherited from cXmlIO
static void | metaCopy (QObject *dest, QObject *src)

## Static Public Attributes
static DeviceInfoList_t | devices
| Pylon camera list. More...

## Properties
int | Width
| Picture width in pixels. More...
int | Height
| Picture height in pixels. More...
int | OffsetX
| Picture horizontal offset in pixels. More...
int | OffsetY
| Picture vertical offset in pixels. More...
int | ExposureTimeRaw
| Raw exposure time. More...
int | BalanceRatioRaw_red
| Red color balance ratio. More...
int | BalanceRatioRaw_green
| Green color balance ratio. More...
int | BalanceRatioRaw_blue
| Blue color balance ratio. More...
Properties inherited from Camera
CameraColor | CameraColor
| Image color type. More...
Properties inherited from cXmlIO
int | xmlID
| Defines uniqe identifier for object in XML file. More...

## Additional Inherited Members
Signals inherited from Camera
void | writeInfo (QString)
Public Attributes inherited from Camera
int | resultX
| Output picture width. More...
int | resultY
| Output picture height. More...
unsigned char * | resultBuffer
| Output image buffer. More...
vector< cv::Point2f > | points
| Output 2D point buffer. More...
bool | readData
| Data readout enable flag. More...
QString | cameraName
| Camera name. More...
int | pixelSize
| Pixel size in bytes. More...
Protected Member Functions inherited from cXmlIO
void | metaDataXmlReader (QXmlStreamReader &stream, QObject &obj, bool isUser=true)
void | metaDataXmlWriter (QXmlStreamWriter &stream, const QObject &obj, bool isUser=true)

## Detailed Description

Basler Gigabit Ethernet camera interface class.

## Constructor & Destructor Documentation

Camera_Basler_GigE | ( |  | ) |
| inline

Initializes default parameters.

## Member Function Documentation

int balanceRatioRaw_blue | ( |  | ) | const
| inline

Gets green color balance ratio.

int balanceRatioRaw_green | ( |  | ) | const
| inline

Gets green color balance ratio.

int balanceRatioRaw_red | ( |  | ) | const
| inline

Gets red color balance ratio.

int connect | ( | int | camera_id | ) |
| virtual

Connects to camera with given ID.

Parameters

  camera_id | ID of camera to connect to

Returns
  Returns 0 on success

Reimplemented from Camera.

int disconnect | ( |  | ) |
| virtual

Disconnects from camera.

Returns
  Returns 0 on success

Reimplemented from Camera.

int exposureTimeRaw | ( |  | ) | const
| inline

Gets raw exposure time.

int grab | ( | cv::Mat * | output = `NULL` | ) |
| virtual

Copies current internal buffer to resultBuffer or given output Mat.

Parameters

  output | optional Mat to copy image to

Returns
  Returns 0 on success

Reimplemented from Camera.

int height | ( |  | ) | const
| inline

Gets picture height in pixels.

int offsetX | ( |  | ) | const
| inline

Gets picture horizontal offset in pixels.

int offsetY | ( |  | ) | const
| inline

Gets picture vertical offset in pixels.

static void refreshDevices | ( |  | ) |
| inline static

Refreshes connected devices.

void setBalanceRatioRaw_blue | ( | const int & | balanceratioraw_blue | ) |
| inline

Sets green color balance ratio.

void setBalanceRatioRaw_green | ( | const int & | balanceratioraw_green | ) |
| inline

Sets green color balance ratio.

void setBalanceRatioRaw_red | ( | const int & | balanceratioraw_red | ) |
| inline

Sets red color balance ratio.

void setExposureTimeRaw | ( | const int & | exposuretimeraw | ) |
| inline

Sets raw exposure time.

void setHeight | ( | const int & | height | ) |
| inline

Sets picture height in pixels.

void setOffsetX | ( | const int & | offsetx | ) |
| inline

Sets picture horizontal offset in pixels.

void setOffsetY | ( | const int & | offsety | ) |
| inline

Sets picture vertical offset in pixels.

void setWidth | ( | const int & | width | ) |
| inline

Sets picture width in pixels.

int start | ( |  | ) |
| virtual

Starts acquisition.

Returns
  Returns 0 on success

Reimplemented from Camera.

int stop | ( |  | ) |
| virtual

Stops acquisition.

Returns
  Returns 0 on success

Reimplemented from Camera.

int sync | ( |  | ) |
| virtual

Sends software trigger to camera.

Returns
  Returns 0 on success

Reimplemented from Camera.

int width | ( |  | ) | const
| inline

Gets picture width in pixels.

## Member Data Documentation

DeviceInfoList_t devices
| static

Pylon camera list.

## Property Documentation

int BalanceRatioRaw_blue
| read write

Blue color balance ratio.

int BalanceRatioRaw_green
| read write

Green color balance ratio.

int BalanceRatioRaw_red
| read write

Red color balance ratio.

int ExposureTimeRaw
| read write

Raw exposure time.

int Height
| read write

Picture height in pixels.

int OffsetX
| read write

Picture horizontal offset in pixels.

int OffsetY
| read write

Picture vertical offset in pixels.

int Width
| read write

Picture width in pixels.

The documentation for this class was generated from the following file:

- camera/Camera_Basler_GigE.h